#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.4 $
#
#   last change: $Author: obo $ $Date: 2004-04-01 14:18:34 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

# --- Globals ------------------------------------------------------

PRJ             = ..
PRJINC			= $(PRJ)$/source
PRJNAME         = soldep
TARGET          = soldep

# --- Settings -----------------------------------------------------

.INCLUDE :settings.mk


# --- Files --------------------------------------------------------

CDEFS+=-DUPDSTRING=\"$(UPD)\"

.IF "$(HJS_TEST)"!=""
CDEFS+=-DHJS_TEST
.ENDIF

DEPOBJFILES= \
    $(OBJ)$/depapp.obj

SRC1FILES = \
    soldlg.src

RES1TARGET = dep
SRS1NAME=$(TARGET)
SRS1FILES = \
    $(SRS)$/soldep.srs

RESLIB1NAME = dep
RESLIB1SRSFILES = \
    $(SRS)$/soldep.srs


OBJFILES        = \
    $(OBJ)$/soldep.obj		\
    $(OBJ)$/soldlg.obj		\
    $(OBJ)$/prjdep.obj		\
    $(OBJ)$/depper.obj		\
     $(OBJ)$/hashtbl.obj		\
    $(OBJ)$/hashobj.obj		\
    $(OBJ)$/connctr.obj		\
    $(OBJ)$/depwin.obj		\
    $(OBJ)$/graphwin.obj	\
    $(OBJ)$/objwin.obj

APP1TARGET=soldepl
APP1OBJS=$(OBJFILES) \
    $(OBJ)$/depapp.obj

#APP1LIBS=	$(LB)$/hashtab.lib

APP1ICON=soldep.ico
APP1STDLIBS= \
            $(SVTOOLLIB)		\
            $(CPPULIB)			\
            $(CPPUHELPERLIB)	\
            $(COMPHELPERLIB)	\
            $(SVLIB)			\
            $(SOTLIB)			\
            $(BTSTRPLIB)		\
            $(TOOLSLIB) 		\
            $(VOSLIB)			\
            $(UNOLIB)			\
            $(OSLLIB)			\
            $(SALLIB)
APP1LINKRES=$(MISC)$/$(TARGET).res


.IF "$(GUI)" == "UNX"
LIB1OBJFILES		= $(OBJFILES)
LIB1ARCHIV              = $(LB)$/libdepper.a
LIB1TARGET              = $(LB)$/dep.lib
.ENDIF

# --- Targets -------------------------------------------------------

ALL : \
    ALLTAR \
    $(BIN)$/applicat.rdb

.INCLUDE :	target.mk

$(BIN)$/applicat.rdb : makefile.mk $(UNOUCRRDB)
    rm -f $@
    $(GNUCOPY) $(UNOUCRRDB) $@
     +cd $(BIN) && \
         regcomp -register -r applicat.rdb \
             -c $(DLLPRE)i18nsearch.uno$(DLLPOST) \
             -c $(DLLPRE)i18npool.uno$(DLLPOST)


